#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>

#define PI 3.141592654

void Set_Mode(unsigned int);
void Cls(char *,int);
void Move(char *,char *,int);

typedef struct vector{
	float	v1,v2,v3;
}VECTOR;

VECTOR UnitVector(VECTOR a);
int SphereInt(VECTOR dir,VECTOR pos,float r);


void main()
{
	int	a,b;
	VECTOR	dir;
	VECTOR	Posicion;		//posicion de la esfera
	float	r;			//radio de la esfera
	char	*Buffer;
	int	pos;
	float	angle;			//para animar un poco la esfera

	Buffer=(char *)malloc(320*200);
	if(Buffer==NULL){
		printf("No hay suficiente memria\n");
		exit(1);
	}
	Posicion.v1=0;
	Posicion.v2=0;
	Posicion.v3=512;
	r=100;
	angle=0;

	Set_Mode(0x13);
	while(!kbhit()){
		Posicion.v1=50*sin(PI*angle/180);	//posicin de la esfera
		Posicion.v2=50*cos(PI*angle/180);

		pos=0;
		for(a=-100;a<100;a++){
			for(b=-160;b<160;b++){
				dir.v1=b;
				dir.v2=a;
				dir.v3=256;
				dir=UnitVector(dir);
				if(SphereInt(dir,Posicion,r)) 
					Buffer[pos]=15;
				else Buffer[pos]=0;
				pos++;
			}
		}
		Move(Buffer,(char *) 0xa0000,(320*200)>>2);
							// Volcar a pantalla
		Cls(Buffer,(320*200)>>2);
							// Borrar buffer
		angle+=5;				// incrementar angulo
							// de rotacin de la
							// esfera
	}
	getch();
	free(Buffer);
	Set_Mode(0x3);
	printf(" bp / savage. Enviar comentarios a bp@ati.es\n");
}

VECTOR UnitVector(VECTOR a){
	VECTOR b;
	float	module;

	module=sqrt(a.v1*a.v1+a.v2*a.v2+a.v3*a.v3);
	if(module){
		b.v1=a.v1/module;
		b.v2=a.v2/module;
		b.v3=a.v3/module;
	} else {
		b.v1=0;
		b.v2=0;
		b.v3=0;
	}
	return(b);
}

int SphereInt(VECTOR dir,VECTOR pos,float r){
	float	b,c;
	float	disc;
	
	b=2*(dir.v1*pos.v1+dir.v2*pos.v2+dir.v3*pos.v3);	
	c=pos.v1*pos.v1+pos.v2*pos.v2+pos.v3*pos.v3-r*r;
	disc=b*b-4*c;
	if(disc>0) return(1);
	else return(0);
}




#pragma	aux Set_Mode=\
"int	10h"\
modify	[ax]\
parm	[ax]

#pragma	aux Cls=\
"xor	eax,eax"\
"rep	stosd"\
modify	[eax ecx edi]\
parm	[edi] [ecx]

#pragma	aux Move=\
"rep	movsd"\
modify	[eax ecx edi]\
parm	[esi] [edi] [ecx]
